Subject: Re: [RFC/PATCH] commit: allow partial commits with relative paths

From: Michael J Gruber <[email-masked]>
Date: Wed, 27 Jul 2011 11:53:40 +0200

Reuben Thomas venit, vidit, dixit 27.07.2011 11:45:
> On 27 July 2011 09:22, Michael J Gruber <[email-masked]> wrote:
>> Junio C Hamano venit, vidit, dixit 25.07.2011 21:02:
>>> Michael J Gruber <[email-masked]> writes:
>>>
>>> Also what is the "same
>>> problem"?
>>
>> The one reported by the OP for commit:
>>
>> git rm ../a
>> git commit -m "blurb" ../a
>> error: pathspec '../a' did not match any file(s) known to git.
> 
> Actually, this is not what I reported. This explains why I couldn't
> quite understand the direction this thread took. Look again:
> 
> $ cat ~/reportbug-git
> $ git rm -f ../INSTALL
> rm 'INSTALL'
> $ git ci -m "INSTALL is now provided by gnulib." ../INSTALL
> error: pathspec 'ALL' did not match any file(s) known to git.
> $ cd ..
> $ git ci -m "INSTALL is now provided by gnulib." INSTALL
> [master 0895314] INSTALL is now provided by gnulib.
>  1 files changed, 0 insertions(+), 1 deletions(-)
>  delete mode 120000 INSTALL
> 
> The thing I didn't understand is that I tried to check in ../INSTALL,
> but git complained about pathspec 'ALL'.

Well, you didn't say so, did you?

Also, we don't know what subdir you were doing this in, but I bet it has
a 7-character name...

I can't reproduce that name truncation with a current git, btw. (So I
won't bother bisecting where we removed a spurious offset by "prefix".)

In any case, I still think git should allow partial commits with staged
deletions from within a subdir, which is what my patch is about.

Michael